> ## Documentation Index
> Fetch the complete documentation index at: https://docs.flowra.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# Get tool by ID

> Get full details of a tool: name, description, input schema, script, and configuration. Use the tool slug or ID when executing or editing the tool.



## OpenAPI

````yaml /api-reference/openapi.json get /api/v1/tools/byId/{id}
openapi: 3.0.0
info:
  title: Flowra API (API Key Endpoints)
  description: >-
    **Flowra** is an AI-powered platform for building agents, workflows, and
    integrations.


    ### Capabilities

    - **Tools & Toolkits** – Define and group tools for agents and workflows.

    - **Workflows** – Orchestrate steps and automate processes.

    - **Triggers** – Schedule or event-based execution.

    - **Auth & Connections** – OAuth, API keys, and connected accounts.

    - **MCP** – Model Context Protocol server integration.

    - **Knowledge / RAG** – Add files and URLs for retrieval-augmented
    generation.


    ### Authentication

    Use the **x-api-key** header with a project API key to access endpoints that
    support API Key auth. Create and manage API keys in the dashboard under your
    project settings.


    Only endpoints that support API Key authentication via the @ApiKeyEnabled()
    decorator.


    Send x-api-key (required). On multi-tenant endpoints, optionally send
    x-username to act as an external user.
  version: '1.0'
  contact:
    name: Flowra
    url: https://flowra.dev
servers:
  - url: https://flowra.dev
    description: Flowra API
security: []
tags:
  - name: Users
    description: User profile
  - name: External Users
    description: End-user identities inside a project (x-username)
  - name: Auth Configs
    description: OAuth and API key configs for toolkits
  - name: Connected Accounts
    description: OAuth connected accounts and link creation
  - name: Toolkits
    description: List and search toolkits
  - name: Tools
    description: List, execute, and manage tools
  - name: Skills
    description: Browse, create, import, and install skills
  - name: Workflow & Agent
    description: Create, run, and inspect workflows and agents
  - name: Triggers
    description: Schedule and event-based trigger instances
  - name: Chat
    description: Threads and streaming agent runs
  - name: File
    description: Upload, list, and download files
  - name: Knowledge
    description: RAG knowledge collections
  - name: Table
    description: Collections and documents
  - name: Sandbox
    description: Ephemeral and durable code sandboxes
  - name: Browser
    description: Live browser sessions and view
  - name: LLM
    description: List AI models and generate completions
  - name: MCP
    description: MCP server management
  - name: usage
    description: Credit balance and usage ledger for the project API key
paths:
  /api/v1/tools/byId/{id}:
    get:
      tags:
        - Tools
      summary: Get tool by ID
      description: >-
        Get full details of a tool: name, description, input schema, script, and
        configuration. Use the tool slug or ID when executing or editing the
        tool.
      operationId: ToolsController_getToolById
      parameters:
        - name: id
          required: true
          in: path
          description: Tool ID (UUID) or slug, depending on lookup
          schema:
            example: 3fa85f64-5717-4562-b3fc-2c963f66afa6
            type: string
        - name: version
          required: false
          in: query
          description: Optional version of the tool to retrieve
          schema:
            example: 2.0.0
            type: string
        - name: toolkitVersions
          required: false
          in: query
          description: >-
            Toolkit version specification. Use "latest" for latest versions or
            bracket notation for specific versions per toolkit.
          schema:
            example: latest
            type: string
      responses:
        '200':
          description: Tool details retrieved successfully
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ToolResponseDtoSuccessResponse'
              example:
                success: true
                message: Operation completed successfully
                data:
                  id: 3fa85f64-5717-4562-b3fc-2c963f66afa6
                  slug: gmail_send_email
                  name: Send Email
                  description: Sends an email via Gmail
                  instructions: Use when the user asks to send an email.
                  toolkitSlug: gmail
                  inputParameters:
                    type: object
                    properties:
                      to:
                        type: string
                  outputParameters:
                    type: object
                    properties:
                      messageId:
                        type: string
                  noAuth: false
                  availableVersions:
                    - 1.0.0
                  version: 1.0.0
                  scopes:
                    - gmail.send
                  tags:
                    - email
                  isImportant: false
                  isDeprecated: false
                  isDisabled: false
                  popularityScore: 12
                  provider: COMPOSIO
                  type: action
                  ragContentHash: ''
                  ragSyncedAt: '2024-01-01T00:00:00.000Z'
                  createdAt: '2024-01-01T00:00:00.000Z'
                  updatedAt: '2024-01-01T00:00:00.000Z'
                  fieldModifiers: {}
                  script: javascript
                  executionCreditCost: 0
      security:
        - x-api-key: []
components:
  schemas:
    ToolResponseDtoSuccessResponse:
      type: object
      properties:
        success:
          type: boolean
          description: Success status
          example: true
        message:
          type: string
          description: Success message
          example: Operation completed successfully
        data:
          type: object
          properties:
            id:
              type: string
              description: Tool UUID
              example: 3fa85f64-5717-4562-b3fc-2c963f66afa6
            slug:
              type: string
              description: Stable tool slug used in execute and agent tool lists
              example: gmail_send_email
            name:
              type: string
              description: Display name
              example: Send Email
            description:
              type: string
              description: What the tool does
              example: Sends an email via Gmail
            instructions:
              type: string
              description: Instructions for when an agent should call this tool
              example: Use when the user asks to send an email.
            toolkitSlug:
              type: string
              description: Parent toolkit slug
              example: gmail
            inputParameters:
              type: object
              description: JSON Schema for arguments
              example:
                type: object
                properties:
                  to:
                    type: string
            outputParameters:
              type: object
              description: JSON Schema for the result
              example:
                type: object
                properties:
                  messageId:
                    type: string
            noAuth:
              type: boolean
              description: True when the tool can run without a connected account
              example: false
            availableVersions:
              description: Published versions
              example:
                - 1.0.0
              type: array
              items:
                type: string
            version:
              type: string
              description: Current version
              example: 1.0.0
            scopes:
              description: Required scopes
              example:
                - gmail.send
              type: array
              items:
                type: string
            tags:
              description: Tags
              example:
                - email
              type: array
              items:
                type: string
            isImportant:
              type: boolean
              description: Highlighted in pickers
              example: false
            isDeprecated:
              type: boolean
              description: Marked deprecated in the catalog
              example: false
            isDisabled:
              type: boolean
              description: Disabled tools cannot be executed
              example: false
            popularityScore:
              type: number
              description: Relative popularity score
              example: 12
            provider:
              type: string
              enum:
                - COMPOSIO
                - LOCAL
            type:
              enum:
                - action
                - poll
                - webhook
              type: string
            ragContentHash:
              type: string
            ragSyncedAt:
              format: date-time
              type: string
            createdAt:
              format: date-time
              type: string
            updatedAt:
              format: date-time
              type: string
            fieldModifiers:
              type: object
            script:
              type: string
              nullable: true
              description: Custom script for this tool when set (language and source code).
              enum:
                - javascript
                - python
            executionCreditCost:
              type: number
              nullable: true
              description: >-
                Credits charged per successful execution. Null = platform
                default. Visible to admins only.
          required:
            - id
            - slug
            - name
            - description
            - instructions
            - toolkitSlug
            - inputParameters
            - outputParameters
            - noAuth
            - availableVersions
            - version
            - scopes
            - tags
            - isImportant
            - isDeprecated
            - isDisabled
            - popularityScore
            - provider
            - type
            - ragContentHash
            - ragSyncedAt
            - createdAt
            - updatedAt
            - fieldModifiers
          example:
            id: 3fa85f64-5717-4562-b3fc-2c963f66afa6
            slug: gmail_send_email
            name: Send Email
            description: Sends an email via Gmail
            instructions: Use when the user asks to send an email.
            toolkitSlug: gmail
            inputParameters:
              type: object
              properties:
                to:
                  type: string
            outputParameters:
              type: object
              properties:
                messageId:
                  type: string
            noAuth: false
            availableVersions:
              - 1.0.0
            version: 1.0.0
            scopes:
              - gmail.send
            tags:
              - email
            isImportant: false
            isDeprecated: false
            isDisabled: false
            popularityScore: 12
            provider: COMPOSIO
            type: action
            ragContentHash: ''
            ragSyncedAt: '2024-01-01T00:00:00.000Z'
            createdAt: '2024-01-01T00:00:00.000Z'
            updatedAt: '2024-01-01T00:00:00.000Z'
            fieldModifiers: {}
            script: javascript
            executionCreditCost: 0
      required:
        - success
        - message
        - data
  securitySchemes:
    x-api-key:
      type: apiKey
      in: header
      name: x-api-key
      description: >-
        Project API key. Create and manage keys in the dashboard under Project →
        API Keys. Send as header: x-api-key: <your-key>

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.